using DualScreenDemo;
using System;
using System.IO;
namespace DBObj
{
    public class SongData
    {
        public string SongNumber { get; set; }
        public string Song { get; set; }
        public string ArtistA { get; set; }
        public string ArtistB { get; set; }
        public string FileName { get; set; }
        public string ArtistASimplified { get; set; }
        public string ArtistBSimplified { get; set; }
        public string SongSimplified { get; set; }
        public int HumanVoice { get; set; }
        public bool isPublicSong { get; set; }

        public PlayState state;

        /*
        public SongData(string songNumber, string category, string song, double plays, string artistA, string artistB, string artistACategory, string artistBCategory, DateTime addedTime, string songFilePathHost1, string songFilePathHost2, string phoneticNotation, string pinyinNotation, string artistAPhonetic, string artistBPhonetic, string artistASimplified, string artistBSimplified, string songSimplified, string songGenre, string artistAPinyin, string artistBPinyin, int humanVoice)
        {
            SongNumber = songNumber;
            // Category = category;
            Song = song;
            // Plays = plays;
            ArtistA = artistA;
            ArtistB = artistB;
            //ArtistACategory = artistACategory;
            //ArtistBCategory = artistBCategory;
            //AddedTime = addedTime;
            SongFilePathHost1 = songFilePathHost1; 
            SongFilePathHost2 = songFilePathHost2;
            //PhoneticNotation = phoneticNotation; 
            //PinyinNotation = pinyinNotation;
            //ArtistAPhonetic = artistAPhonetic;
            //ArtistBPhonetic = artistBPhonetic;
            ArtistASimplified = artistASimplified;
            ArtistBSimplified = artistBSimplified;
            SongSimplified = songSimplified;
            //SongGenre = songGenre;
            //ArtistAPinyin = artistAPinyin;
            //ArtistBPinyin = artistBPinyin;
            HumanVoice = humanVoice; 
        }
        
        */
        public SongData(string songNumber, string song, string filename, int humanVoice, bool isPublic)
        {
            SongNumber = songNumber;
            Song = song;
            FileName = filename;
            HumanVoice = humanVoice;
            isPublicSong = isPublic;
        }
        public SongData(string songNumber, string song, string artistA, string artistB, string filename, string artistASimplified, string artistBSimplified, string songSimplified, int humanVoice)
        {
            SongNumber = songNumber;
            Song = song;
            ArtistA = artistA;
            ArtistB = artistB;
            FileName = FindExistingPath(filename);
            ArtistASimplified = artistASimplified;
            ArtistBSimplified = artistBSimplified;
            SongSimplified = songSimplified;
            HumanVoice = humanVoice;
            isPublicSong = false;
        }
        private string FindExistingPath(string filename)
        {
            var servers = new[] { @"\\svr01\", @"\\svr02\", @"\\svr01\e", @"\\svr02\e" };
            foreach (var server in servers){
                string fullPath = Path.Combine(server, filename);
                if (File.Exists(fullPath)) return fullPath;
            }
            return filename; // 找不到就回原本的 filename，不加路徑
        }
        public void SetState(PlayState s) => state = s;

        public PlayState GetState()
        {
            return state;
        }

        public override string ToString()
        {

            return !string.IsNullOrWhiteSpace(ArtistB)
                ? String.Format("{0} - {1} - {2}", ArtistA, ArtistB, Song)
                : String.Format("{0} - {1}", ArtistA, Song);
        }
    }
}